'copyright April 24, 2002, Alyce Watson

    if val(Version$)<3 then
        notice "For Liberty BASIC 3!"
        end
    end if

    midi$="spiderdance.mid"   'background music
    musicLenght=0   'play length of midi
    secs=0          'how long midi has been playing
    nValue=1        'card back style
    realbet=50      'amount bet on hand
    nc=1            'number of cards played this game
    dpoints=0       'dealer total points in a hand
    ppoints=0       'player total points in a hand
    dealerAce=0     'flag for aces-- dealer
    playerAce=0     'flag for aces-- player
    val=0           'value of current card dealt
    purse=3000      'players money
    flipCard=0      'dealer face-down card
    gameStart=0     'flag for initializing game
    muon=1          'flag for music on
    playerx=110:dealerx=110  'x card positions for next card
    dim scard(208)  'temporary array for shuffling
    dim pcard(104)  'array holding cards for game after shuffle
    dim dcards(12)  'array holding cards for current hand (for removal)

nomainwin
    WindowWidth=640:WindowHeight=480
    UpperLeftX=int((DisplayWidth-640)/2)
    UpperLeftY=int((DisplayHeight-480)/2)

button #1.h, "  HIT  ",[hit],UL,430,400,90,30
button #1.s, " STAND ",[dealer.total],UL,530,400,90,30
button #1.b, "CHANGE BET",[bet],UL,15,400,180,30
menu #1, "&File","&New Game",[new.game],"&Bet",[bet],"&Exit",[quit]
menu #1, "&Music","Music &On",[music.on],"Music O&ff",[music.off],_
        "&Change Song",[change]
menu #1, "&Help","House &Rules",[house.rules],"&About",[about]
open "Black Jack" for graphics_nsb_nf as #1
    print #1, "trapclose [quit]"
    print #1, "down; fill blue;backcolor blue;color black;font arial 0 25; flush"
    gosub [print.bet]
    print #1.h, "!font arial 0 25"
    print #1.s, "!font arial 0 25"
    print #1.b, "!font arial 0 25"
    gosub [init]
    timer 1000, [check.music]

[loop]
    wait

[quit]
    timer 0: close #1:close #qc
    r=ReleaseDC(hWnd,hDC)
    r=mciSendString("close music")
    end

[new.game]
    gameStart=1
    nValue=1:realbet=50:nc=1:dpoints=0:ppoints=0
    dealerAce=0:playerAce=0:val=0:purse=3000
    playerx=110:dealerx=110

    gosub [choose.back]
    cursor hourglass
    print #1, "delsegment 2;redraw"
    x=200:y=150

    for i=1 to 6
        call DrawBack hWnd,nValue,x,y
        x=x+2:y=y-2
    next

    call SetDefaultValues
    gosub [shuffle]
    gosub [print.bet]
    print #1, "place 25 150;font arial 0 25;\Dealer"
    print #1, "place 25 250;font arial 0 25;\Player"
    cursor normal


[deal.hand]
    if purse<=0 then
        confirm "You are out of money.  Start a new game?"; answer$
        if answer$ = "no" then [quit]
        if answer$ = "yes" then [new.game]
    end if

    gosub [clear.hand.array]
    dpoints=0:ppoints=0:dealerAce=0:playerAce=0
    if nc>=90 then gosub [shuffle]
    nc=nc+1:nCard=pcard(nc)
    dcards(1)=nCard

    call SetCardStatus nCard, 1
    call DealCard, hWnd, nCard, 10, 270 'player's first
    val=GetCardValue(nCard)
    if val=1 then val=11:playerAce=1
    ppoints=ppoints+val
    call CardWave

    nc=nc+1:nCard=pcard(nc)
    dcards(2)=nCard
    flipCard=nCard
    call SetCardStatus flipCard, 0
    call DealCard,hWnd,flipCard,10,20  'dealer's first
    call CardWave


    val=GetCardValue(nCard)
    if val=1 then val=11:dealerAce=1
    dpoints=dpoints+val

    nc=nc+1:nCard=pcard(nc)
    dcards(3)=nCard
    call DealCard hWnd,nCard,110,270  'player's second
    val=GetCardValue(nCard)
    if val=1 and playerAce=0 then val=11:playerAce=1
    ppoints=ppoints+val
    call CardWave


    nc=nc+1:nCard=pcard(nc)
    dcards(4)=nCard
    call DealCard hWnd,nCard,110,20   'dealer's second
    val=GetCardValue(nCard)
    if val=1 and dealerAce=0 then val=11:dealerAce=1
    dpoints=dpoints+val
    call CardWave

    playerx=110:dealerx=110
    nhand=4
    if ppoints=21 then notice "You have 21!":goto [dealer.total]
    wait


[shuffle]
    cursor hourglass
    playwave "shuffle.wav",async
    gosub [erase]
    print #1, "place 450 200;font arial 0 25;color yellow;\Shuffling...\please wait"

    for z = 1 to 208
        scard(z) = z
    next z

    for v = 1 to 104
        [again]
        j = int((rnd(1)*208)+1)
        if scard(j)=0 then [again]
        scard(j)=0
        if j > 104 then j = j - 104
        pcard(v)=j
    next v

    nc=0
    cursor normal
    playwave "shuffle.wav"
    playwave "shuffle.wav"
    gosub [print.bet]
    return

[print.bet]
    gosub [erase]
    print #1, "color black"
    print #1, "place 5 200;font arial 0 25;\Current Bet: $";realbet;"  "
    print #1, "place 450 200;\Player has:            \$";purse;"                    "
    return

[erase]
    print #1, "place 440 160;color blue;backcolor blue"
    print #1, "boxfilled 640 260"
    RETURN


[hit]
    if gameStart=0 then notice "Please choose NEW GAME from the file menu.":wait
    playerx=playerx+100 :nhand=nhand+1
    nc=nc+1:nCard=pcard(nc)
    dcards(nhand)=nCard
    call DealCard hWnd,nCard,playerx,270
    call CardWave


    val=GetCardValue(nCard)
    if val=1 and playerAce=0 then val=11:playerAce=1
    ppoints=ppoints+val
    if ppoints>21 and playerAce=1 then ppoints=ppoints-10:playerAce=2
    if ppoints>21 then
        purse=purse-realbet
        gosub [show.dealer.card]
        playwave "lose.wav"
        gosub [print.bet]
        gosub [remove.cards]
        goto [deal.hand]
    end if
    if ppoints=21 then notice "You have 21!":goto [dealer.total]
    wait

[dealer.total]
    if gameStart=0 then notice "Please choose NEW GAME from the file menu.":goto [loop]
    gosub [show.dealer.card]
[d.total]
    if dpoints>16 then  'dealer has more than 16, end hand
        if dpoints>ppoints then
            purse=purse-realbet
            playwave "lose.wav"
            gosub [print.bet]
        end if
        if dpoints<ppoints then
            purse=purse+realbet
            playwave "win.wav"
            gosub [print.bet]
        end if
        if dpoints=ppoints then
            playwave "even.wav"
        end if
        gosub [remove.cards]
        goto [deal.hand]
    end if

    dealerx=dealerx+100 :nhand=nhand+1
    nc=nc+1:nCard=pcard(nc)
    dcards(nhand)=nCard
    call DealCard hWnd,nCard,dealerx,20
    call CardWave

    val=GetCardValue(nCard)
    if val=1 and dealerAce=0 then val=11:dealerAce=1
    dpoints=dpoints+val
    if dpoints>21 and dealerAce=1 then dpoints=dpoints-10:dealerAce=2
    if dpoints>21 then
        purse=purse+realbet
        playwave "win.wav"
        gosub [print.bet]
        gosub [remove.cards]
        goto [deal.hand]
    end if
    goto [d.total]

[show.dealer.card]
    call RemoveCard hWnd, flipCard
    call SetCardStatus flipCard,1   '0=facedown,1=faceup
    call DealCard hWnd,flipCard,10,20
    return

[remove.cards]
    for t = 1 to nhand
        nCard=dcards(t)
        call RemoveCard hWnd,nCard
    next t
    return

[clear.hand.array]
    for t = 1 to 12
        dcards(t)=0
    next t
    return

[choose.back]
WindowWidth=480:WindowHeight=200
button #ch.1, "One",[one.back],UL,10,130,71,30
button #ch.2, "Two",[two.back],UL,85,130,71,30
button #ch.3, "Three",[three.back],UL,160,130,71,30
button #ch.4, "Four",[four.back],UL,235,130,71,30
button #ch.5, "Five",[five.back],UL,310,130,71,30
button #ch.6, "Six",[six.back],UL,385,130,71,30
open "Choose Back" for dialog_modal as #ch
print #ch, "trapclose [close.ch]"
    hCh=hwnd(#ch)

    x=10:y=10
    for nCard=1 to 6
        call DrawBack hCh,nCard,x,y
        x=x+75
    next nCard
    wait

[one.back]
    nValue=1:goto [close.ch]
[two.back]
    nValue=2:goto [close.ch]
[three.back]
    nValue=3:goto [close.ch]
[four.back]
    nValue=4:goto [close.ch]
[five.back]
    nValue=5:goto [close.ch]
[six.back]
    nValue=6

[close.ch]
    call SetCurrentBack nValue
    close #ch
    return

[bet]
    bets$(0)="50"
    bets$(1)="100"
    bets$(2)="150"
    bets$(3)="200"
    bets$(4)="250"
    bets$(5)="300"
    bets$(6)="350"
    bets$(7)="400"
    bets$(8)="450"
    bets$(9)="500"

WindowWidth = 150
WindowHeight = 125
button #b.1, "  OK  ", [doBet], UL, 30, 10
combobox #b.2, bets$(, [betLoop], 30, 50, 100, 200
statictext #b.3, "$",10,50,15,15
open "Make Your Bet" for dialog_modal as #b
    print #b, "trapclose [doBet]"
    print #b.2, "select ";bets$(0)

[betLoop]
    wait

[doBet]
    print #b.2, "selection? realbet$"
    realbet=val(realbet$):if realbet<50 then realbet=50
    close #b
    gosub [print.bet]
    wait

[house.rules]
timer 0
notice "House Rules" + chr$(13) + "The object of the game is to achieve a point total of 21, or "+_
"as close to 21 as possible without going over.  If player and dealer tie, it is a standoff, with "+_
"no money won or lost.  If player has a better hand than dealer, player wins and his money "+_
"is increased by the amount of the bet.  If dealer has a better hand, player loses and loses "+_
"the amount of the bet.  A hand that goes over 21 points automatically loses.  Cards points are "+_
"counted at their face value, except for Jacks, Kings and Queens, which count 10 and Aces may "+_
"be counted as 1 or 11.  Player chooses HIT if another card is desired, and STAND to stay "+_
"with the hand as it is.  The deck consists of 4 regular decks shuffled together.  A reshuffle "+_
"occurs when half of the cards have been used.  House Rules do not allow bonuses or splitting "+_
"of pairs.  The amount of bet may be changed at any time.  When player runs out of money, the game is over."
    timer 1000, [check.music]
    wait

[about]
    timer 0
    msg$="About Black Jack" + chr$(13)+_
    "Black Jack was written in Liberty BASIC v3.01." + chr$(13) + chr$(169) + _
    "2002, Alyce Watson" + chr$(13) + chr$(13) + _
    "Music is Spider Dance and Pecan Pie, composed and arranged by Thomas W. Watson," +chr$(13) + chr$(169) + _
    "   1997"
    notice msg$
    timer 1000, [check.music]
    wait

[close.file]
    r=mciSendString("close music")
    secs=0
    RETURN

[open.file]
    startTime=time$("ms")
    r=mciSendString("open " + midi$ +" type sequencer alias music")
    r=mciSendString("set music time format ms")
    r$=mciSendString$("status music length")
    musicLength=val(r$)  'length of midi
    secs=0
[play.file]
    r=mciSendString("play music")
    return

[check.music]
    newTime=time$("ms")
    secs = (newTime-startTime)
    if secs>musicLength then
        gosub [close.file]
        gosub [open.file]
    end if
    wait

[music.on]
    muon=1
    r=EnableMenuItem(hMenu,IDoff,0)
    r=EnableMenuItem(hMenu,IDon,1)
    gosub [open.file]
    timer 1000, [check.music]
    wait

[music.off]
    muon=0
    r=EnableMenuItem(hMenu,IDoff,1)
    r=EnableMenuItem(hMenu,IDon,0)
    r=mciSendString("close music")
    timer 0
    wait

[change]
    if midi$="spiderdance.mid" then midi$="pecanpie.mid" else midi$="spiderdance.mid"
    r=mciSendString("close music")
    r=mciSendString("open " + midi$ +" type sequencer alias music")
    r$=mciSendString$("status music length")
    musicLength=val(r$)  'length of midi
    r=mciSendString("play music")
    wait

[init]
    hWnd=hwnd(#1)
    hDC=GetDC(hWnd)
    hParent=GetParent(hWnd)
    hMenuTop=GetMenu(hParent)
    hMenu=GetSubMenu(hMenuTop,1)
    IDon=GetMenuItemID(hMenu,0)
    IDoff=GetMenuItemID(hMenu,1)
    r=EnableMenuItem(hMenu,IDon,1)
    r=SetBkMode(hDC,_TRANSPARENT)

    open  "qcard32.dll" for dll as #qc
    call InitializeDeck,hWnd
    call SetCardStatus 14,1
    call SetCardStatus 11,1
    call DrawCard hWnd,14,290,190
    call DrawCard hWnd,11,302,202
    r=StretchBlt(hDC,250,110,150,221,hDC,290,190,91,116)

    print #1, "backcolor white; color darkblue"
    print #1, "font Arial 0 80;place 120 60"
    print #1, "\Black Jack"
    print #1, "color darkred"
    print #1, "place 124 64;\Black Jack"
    print #1, "backcolor blue;color black;flush"
    gosub [open.file]
    RETURN

''''''''''''''''''''
'subs and functions:
Sub InitializeDeck hndle
    calldll #qc, "InitializeDeck",hndle as long,r as long
    End Sub

sub DrawCard hndle,nC,x,y
    calldll #qc, "DrawCard",hndle as long,nC as long,_
        x as long,y as long,r as void
    End sub

Sub SetCardStatus nC,face
    'face:  0=facedown,1=faceup
    calldll #qc, "SetCardStatus",nC as long,_
    face as long,r as void
    End Sub

Sub DealCard hndle,nC,x,y
    calldll #qc, "DealCard",hndle as long,nC as long,_
    x as long,y as long,r as void
    End Sub

Sub DrawBack hndle, nV, x, y
    calldll #qc, "DrawBack",hndle as long,_
    nV as long,x as long,y as long,r as void
    End Sub

Function GetCardValue(nC)
    calldll #qc, "GetCardValue",nC as long,_
    value as long
    if value>10 then value=10
    GetCardValue=value
    End Function

Sub RemoveCard hndle,nC
    calldll #qc, "RemoveCard",hndle as long,_
    nC as long,r as void
    End Sub

Sub SetCurrentBack nV
    calldll #qc, "SetCurrentBack",nV as long,r as void
    End Sub

sub CardWave
    playwave "card.wav"
    t=time$("ms")+450
    while time$("ms")<t
    wend
    end sub

Sub SetDefaultValues
    calldll #qc, "SetDefaultValues",r as void
    End Sub

Function mciSendString(s$)
    calldll #winmm,"mciSendStringA",s$ as ptr,_
    0 as ulong,0 as long,0 as long,_
    mciSendString as long
    End Function

Function mciSendString$(s$)
    'Buffer will contain a return string from
    'the function, if there is one.
    buffer$=space$(1024)+chr$(0)

    calldll #winmm,"mciSendStringA",s$ as ptr,buffer$ as ptr,_
        1028 as long, 0 as long, r as long

    'truncate returned string at null character
    buffer$=left$(buffer$, instr(buffer$, chr$(0)) - 1)
        if r>0 then
            mciSendString$="error"
        else
            mciSendString$=buffer$
        end if
    End Function

Function SetBkMode(hdc, mode)
    calldll #gdi32, "SetBkMode",hdc as long,_
    mode as long,SetBkMode as long
    End Function

Function ReleaseDC(hndle,hdc)
    calldll #user32,"ReleaseDC",hndle as long,_
    hdc as long,ReleaseDC as long
    End Function

Function GetDC(hndle)
    calldll #user32, "GetDC", hndle as long,_
        GetDC as long
    End Function

Function GetParent(hndle)
    CallDLL #user32, "GetParent", hndle as long,_
    GetParent as long
    End Function

Function StretchBlt(hdcS,x1,y1,w1,h1,hdcD,x2,y2,w2,h2)
    calldll #gdi32,"StretchBlt",hdcS as long,_
    x1 as long,y1 as long,_
    w1 as long,h1 as long,_
    hdcD as long,x2 as long,y2 as long,_
    w2 as long,h2 as long,_SRCCOPY as long,_
    StretchBlt as long
    End Function

Function EnableMenuItem(hM,ID,enable)
    calldll #user32, "EnableMenuItem", hM as long, ID as long,_
    enable as long, EnableMenuItem as long
    End Function

Function GetMenu(hndle)
    calldll #user32, "GetMenu", hndle as long,_
        GetMenu as long
    End Function

Function GetSubMenu(mnu,pos)
    calldll #user32, "GetSubMenu", mnu as long,_
        pos as long, GetSubMenu as long
    End Function

Function GetMenuItemID(mnu,pos)
    calldll #user32, "GetMenuItemID", mnu as long,_
        pos as long, GetMenuItemID as long
    End Function

